#ifndef _WALKTHROUGHRECORDER_H__
#define _WALKTHROUGHRECORDER_H__

#include "common.h"
#include <fstream>

namespace CHCDemoEngine
{

class Camera;


/** Records given walkthrough
*/
class WalkThroughRecorder
{
public:
	/** Writes walkthrough frames to file.
	*/
	WalkThroughRecorder(const std::string &filename);
	/** Writes current camera data.
	*/
	void WriteFrame(Camera *cam);
	/** Reads next frame
	*/
	void ReadNextFrame(Camera *cam);

protected:

	std::ofstream mFile;
};

/** Replays a given walkthrough
*/
class WalkThroughPlayer
{
public:
	/** Writes walkthrough frames to file.
	*/
	WalkThroughPlayer(const std::string &filename);
	/** Reads next frame
	*/
	void ReadNextFrame(Camera *cam);

protected:

	std::ifstream mFile;
};


}

#endif
